using FoodsharingSiegen.Contracts.Entity;
using FoodsharingSiegen.Server.Data.Service;
using FoodsharingSiegen.Server.Dialogs;
using FoodsharingSiegen.Shared.Helper;
using Microsoft.AspNetCore.Components;

namespace FoodsharingSiegen.Server.Controls
{
    public partial class ProspectContainer
    {
        [Parameter] public Prospect? Prospect { get; set; }
        
        [Parameter] public ProspectStateFilter StateFilter { get; set; }
        
        [Parameter] public string? CssClass { get; set; }
        
        [Parameter] public Func<Task>? OnDataChanged { get; set; }

       
        private async Task AddInteraction(InteractionType type)
        {
            if (Prospect != null && OnDataChanged != null)
            {
                var headerText = $"{type.Translate(AppSettings)} eintragen";
                
                await InteractionDialog.ShowAsync(ModalService, new(type, Prospect.Id, headerText, OnDataChanged));
            }
                
        }

        private List<Interaction> GetTyped(InteractionType type)
        {
            return Prospect?.Interactions?.Where(x => x.Type == type).ToList() ?? [];
        }

        private async Task EditProspectAsync()
        {
            await EditProspectDialog.ShowAsync(ModalService, () => InvokeAsync(StateHasChanged), Prospect);
        }

        /// <summary>
        ///     Gets or sets the value of the prospect service (ab)
        /// </summary>
        [Inject]
        public ProspectService ProspectService { get; set; } = null!;
        
        private async Task RemoveInteraction(Guid arg)
        {
            var type = Prospect?.Interactions.FirstOrDefault(x => x.Id == arg)?.Type;
            var typeName = type != null ? type.Value.Translate(AppSettings) : "Interaktion";
            
            var confirm = await Message.Confirm($"{typeName} wirklich entfernen?", "Bestätigen", o =>
            {
                o.ConfirmButtonText = "Ja, wirklich!";
                o.CancelButtonText = "Abbrechen";
                o.ShowMessageIcon = false;
            });

            if (confirm)
            {
                var removeR = await ProspectService.RemoveInteraction(arg);
                if(removeR.Success && OnDataChanged != null) await OnDataChanged();
            }
        }
    }
}